/**
 * Write a description of class Kanal here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
import java.io.*;
import java.util.*;

public class Kanal {
    double prob = 0.01;     // Bitfehler-Wahrscheinlichkeit 
    int kopfLaenge = 1000;  // Anzahl der Bytes am Anfang der Datei, 
                            // die ohne Fehler dirket kopiert werden
    int blockLaenge = 8;
    int verbose     = 0;

    boolean useParity = true;
    String inFile = "test.bmp";
    String outFile = "out.bmp";
    
    // Zhler fr Statistik
    int anzahlBitFehler    = 0;
    int anzahlBytes        = 0;
    int anzahlRahmen       = 0;
    int anzahlRahmenFehler = 0;
    int versuche           = 0;
    int c_char             = 0;

    /***************************************************************************
     * Bestimme aus laenge Bytes im array die Laengsparitaet und gebe diese als
     * Byte zurueck
     */
    byte paritaet(byte[] in) {
        byte paritaet = 0;

        return paritaet;
    }

    /**
     *  Einfacher Test der Paritt-Berechnung
     */
    public void test() {
        String text = "Friedberg";
        byte[] b = text.getBytes();
        byte p = paritaet(b);
        System.out.println("Paritaet von " + text + ": " + Integer.toBinaryString(p));
    }

    public void setProb(double prob) {
        this.prob = prob;
    }

    public void setUseParity(boolean useParity) {
        this.useParity = useParity;
    }

    public double getProb() {
        return prob;
    }

    public void setInFile(String inFile) {
        this.inFile = inFile;
    }

    public void setOutFile(String outFile) {
        this.outFile = outFile;
    }

    /***************************************************************************
     * Kanalsimualtion Mit der Wahrscheinlichkeit prob werden einzelne Bits
     * verflscht Argument: Byte-Array mit Daten (= Rahmen) Rckgabe: Byte-Array
     * mit neuen Daten, gegebenfalls mit Fehlern
     */
    private byte[] uebertrage(byte[] in) {
        boolean rahmenFehler = false;
        byte[] out = new byte[in.length];
        anzahlBytes += in.length;
        for (int i = 0; i < in.length; i++) {
            out[i] = in[i];
            byte pos = 1; // Bit-Maske
            for (int j = 0; j < 8; j++) { // ber alle 8 bits
                // Erzeuge Zufallszahl im Intervall [0,1] und teste,
                // ob kleiner als eingestellte Fehlerwahrscheinlichkeit
                if (Math.random() < prob) {
                    // Bit mittels XOR umdrehen
                    out[i] ^= pos;
                    ++anzahlBitFehler;
                    rahmenFehler = true; // ganzen Rahmen als falsch markiern
                }
                pos <<= 1; // Maske fr nchstes Bit
            }
        }
        ++anzahlRahmen;
        if (rahmenFehler)
            ++anzahlRahmenFehler;
        return out;
    }

    /***************************************************************************
     * Fuege an Daten ein weiteres Byte mit Paritaet an
     */
    private byte[] bildeRahmen(byte[] in) {
        // neuer Rahmen mit einem zusaetzlichen Byte fuer Paritaet
        byte[] out = new byte[in.length + 1];
        System.arraycopy(in, 0, out, 0, in.length);
        out[in.length] = paritaet(in);
        if (verbose > 0) {
            System.out.println("******************************");
            for (byte b : out) {
                System.out.format("%4i %s", b, Integer.toBinaryString(b));
            }
        }
        return out;
    }

    /***************************************************************************
     * Teste, ob Rahmen Fehler enthaelt
     */
    private boolean rahmenFalsch(byte[] in) {
        if (paritaet(in) != 0) {
            return true;
        } else {
            return false;
        }
    }

    /***************************************************************************
     * entferne letztes Byte mit Paritaet
     */
    private byte[] leseRahmen(byte[] in) {
        byte[] out = new byte[in.length - 1];
        System.arraycopy(in, 0, out, 0, out.length);
        return out;
    }

    /***************************************************************************
     * 
     */
    static void printHelp() {
        System.out.println("USAGE: " + " [ arg1 arg2 ... ]");
        System.out
                .println("  -v        :  verbose mode                         D=no");
        System.out
                .println("  -r        :  raw mode, parity check disabled      D=no");
        System.out
                .println("  -p x      :  set probabilty to x                  D=0.01");
        System.out
                .println("  -k m      :  copy header of m Bytes               D=1000");
        System.out
                .println("  -b n      :  set block length to n                D=8");
        System.out
                .println("  -i file   :  input file                           D=test.bmp");
        System.out
                .println("  -o file   :  output file                          D=out.bmp");

    }

    /***************************************************************************
     * bergebe Parameter in einem String
     */
    public void setParamString(String args) {
        setParam(args.split(" "));
    }

    private void setParam(String[] args) {
        for (int i = 0; i < args.length; i++) {
            if (args[i].equals("-h")) {
                printHelp();
            } else if (args[i].equals("-v")) {
                ++verbose;
            } else if (args[i].equals("-r")) {
                useParity = false;
            } else if (args[i].equals("-k")) {
                kopfLaenge = (new Integer(args[++i])).intValue();
            } else if (args[i].equals("-b")) {
                blockLaenge = (new Integer(args[++i])).intValue();
            } else if (args[i].equals("-p")) {
                prob = (new Double(args[++i])).doubleValue();
            } else if (args[i].equals("-i")) {
                inFile = args[++i];
            } else if (args[i].equals("-o")) {
                outFile = args[++i];
            } else {
                System.out.println("unknown option <" + args[i] + ">");
                printHelp();
            }
        }
    }
        
    public void printSettings() {
        System.out.println("Eingang:                     " + inFile);
        System.out.println("Ausgang:                     " + outFile);
        System.out.println("Paritaetspruefung:           " + useParity);
        System.out.println("kopierter Kopf:              " + kopfLaenge
                + " Bytes");
        System.out.println("Blocklaenge:                 " + blockLaenge
                + " Bytes");
        System.out.println("Fehlerwahrscheinlichkeit:    " + prob);
             }
    /**
     * Fhre Simulation durch
     */
    public void simulation() {
         anzahlBitFehler    = 0;
         anzahlBytes        = 0;
         anzahlRahmen       = 0;
         anzahlRahmenFehler = 0;
         versuche           = 0;
         c_char             = 0;
    	
    	
        System.out.println(inFile + " -> " + outFile + " p= " + prob
                + " Pruefung= " + useParity);
        int anzeiger = 0;
        int rahmenFehler = 0;
        
        try {
            DataInputStream din = new DataInputStream(new FileInputStream(
                    inFile));
            DataOutputStream dout = new DataOutputStream(new FileOutputStream(
                    new File(outFile)));
            int readBytes;
            byte[] b = new byte[kopfLaenge];
            din.read(b);
            dout.write(b);
            c_char = kopfLaenge;

            byte[] tmp = new byte[blockLaenge];
            while ((readBytes = din.read(tmp)) > 0) {
                if (readBytes == blockLaenge) {
                    b = tmp;
                } else {
                    b = new byte[readBytes];
                    System.arraycopy(tmp, 0, b, 0, readBytes);
                }
                c_char += readBytes;
                anzeiger += readBytes;
                if (anzeiger > 10000) {
                    anzeiger = 0;
                    System.out.print(".");
                }
                byte[] rahmen = bildeRahmen(b);
                byte[] erhalten = uebertrage(rahmen);
                while (useParity & rahmenFalsch(erhalten)) {
                    ++versuche;
                    erhalten = uebertrage(rahmen);
                }
                byte[] result = leseRahmen(erhalten);
                dout.write(result);
                if (!Arrays.equals(rahmen, erhalten)) {
                    ++rahmenFehler;
                }
            }
            dout.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }

        System.out.println();
        printSettings();
        System.out.println("Dateigroesse:                " + c_char + " Bytes");
        System.out.println("Eingefuegte Bitfehler:       " + anzahlBitFehler);
        System.out.format("gemessene Fehlerhaeufigkeit: %.4f %% %n", 100.
                * anzahlBitFehler / 8. / anzahlBytes);
        System.out.println("uebertragene Rahmen:         " + anzahlRahmen);
        System.out
                .println("davon falsche Rahmen:        " + anzahlRahmenFehler);
        System.out.println("Wiederholungen:              " + versuche);
        System.out.println("nicht erkannte Rahmenfehler: " + rahmenFehler);
    }
}
